# iAnomaly

Development of iAnomaly, a program for comparing Anomaly Detection 
algorithms in an automated manner.

## Acknowledgements
This code has been developed by **Xavier Gombau** (Universitat Politècnica de Catalunya), using already existing code from
**James Cheney** (University of Edinburgh), **Ghita Berrada** (King's College, London) 
and **Sidahmed Benabderrahmane** (New York University).

## Requirements
Install first all the requirements of the program:
```
pip install -r requirements.txt
```

## Usage of Snakemake
Snakemake is a very useful tool to run automated tests efficiently.

It is important to configure the automated tests. 
An example is included in `config_example.yaml`. 
You can change directory names, timeouts, files to scan, algorithms to apply,
and many other options.
 
Once the `.yaml` (although it can also be a `.json`) is set up, it's time
to run the desired tests. To do that, just execute the following command:

```
snakemake --configfile config_example.yaml
```

This will execute by default the first rule (all) of `Snakefile`.

#### Options
You can add the following useful options to the previous snakemake command:

- `--resources mem_mb=1000`: limit the memory (in MB) that each core can use.
This is very useful in large datasets, since the system can run out of
memory and collapse. **IMPORTANT: This limit is not used by krimp or slim
binaries, i.e. the system can still collapse when using binary files!**
- `--cores 4`: specify parallelism (max_cores by default). You can limit
the maximum number of cores that snakemake can use.
- `-n`: dry run. That means that all jobs are printed but not actually
executed. This can be useful for debugging purposes.

## Algorithms
There are the following algorithms for anomaly detection implemented in 
this version of iAnomaly. Note that all of them use the same input/output
format (.csv).

The followed naming convention is: 

`results/{context}/{dataset}.{algorithm}.{mode}.{scored or ranked}.csv`

where `context` is the dataset path relative to `datasets` directory.
Any result generated by an algorithm ends with `.scored.csv` and the results
generated by the checker end with `.ranked.csv`.

### Attribute Value Frequency and Attribute Value Compression
Script: `ad.py`

This script implements both AVF and AVC algorithms for anomaly detection.
Its performance is pretty fast, and the accuracy of the results vary
depending on the dataset. Two modes can be set: `batch` or `stream`.

To run manually this script, see how it can be executed:
```
python3 ad.py -h
```

### KL-means
Script: `klmeans.py`

The file `klmeans.py` contains an experimental (meta-)algorithm based
on an information-theoretic variant of k-means clustering.  (The name "KL-means"
is a weak pun on "k-means" and "Kullback-Leibler (KL) divergence", a
distance-like function on probability distributions in information
theory.)

There are two versions, a batch version and a stream version:

* The batch version takes two parameters, K and N.  The K parameter sets the 
  number of clusters to try to find, and the N parameter sets the number of 
  iterations to run for.  The end result is a score file which also includes
  the final assignment of objects to clusters 0..K-1.  This makes N+1 passes
  over the data so it can take a while, but usually small values of N (<5) work.
* The stream version does not take any additional parameters.  It starts with 
  one cluster and compresses using that as in AVC until there is evidence that
  another cluster is needed.  This is based on a heuristic: if we see objects
  compress very badly (i.e. worse than simply encoding the attributes in binary)
  then we spawn a new model for a new cluster.  Again, the output includes 
  score (= compressed size) and final cluster assignment of each object.

The intention is that the scores can be used (as with AVC and AVF) as anomaly 
scores.  The cluster assignment information is (at this point) ostly for 
debugging purposes, but might have other uses.

To run manually this script, see how it can be executed:
```
python3 klmeans.py -h
```
**REMARK: Setting up k=1 (only using 1 model) we get the same algorithm as AVC.**

REF: Refer to paper "*An Empirical Comparison of NML Clustering
Algorithms*" for more information.

### Krimp (OC3)
Script: `krimp.py`

We have also added a Linux binary based on the Krimp system, 
which mines the frequent (closed) itemsets and then attempts to 
identify a subset of them that "compress the data well". 
The end result includes scores for the objects indicating 
their "compressed size", which, like in AVC, 
we interpret as anomaly scores. 
There are currently no parameters (Krimp does have some, 
but we currently hard-wire them to reasonable values).

To run manually this script, see how it can be executed:
```
python3 krimp.py -h
```

### Krimpstar
Script: `krimpstar.py`

It is similar to KL-means. It uses the k-clustering technique applying 
Krimp in each datapoint instead of AVC.

To run manually this script, see how it can be executed:
```
python3 krimpstar.py -h
```
**REMARK: Setting up k=1 (only using 1 model) we get the same algorithm as Krimp.**

REF: Refer to paper "*Identifying the Components*" for more information.


### Slim
Current script: `slim_upc.py`. *The script `slim.py` is old and not updated, but it
can be of help or for comparing purposes, as it uses another binary.*

It is similar to Krimp but uses a more sophisticated way to choose the
candidates to be evaluated. It can have a longer runtime, but usually
has better results. Furthermore, there is a method for every class of 
anomalies (see Paper "*Efficiently discovering unexpected pattern-co-occurrences*").

The methods we can use in this script are:

- `0D`  Class 0 anomalies based on transactions length
- `1D`  Class 1 anomalies based on pattern supports
- `2D`  Class 2 anomalies based on unexpected co-occurrences
- `OC3`  Class 1 anomalies based on compression (OC3)
- `baseline2D`  Class 2 anomalies based on unexpected co-occurrences using all frequent patterns (only in small datasets)

The first method is pretty fast. However, the other ones (especially the
last one) can last a lot. This is why a timeout is implemented, which can be
configured in the `.yaml` file or as an option if manually ran.

Especially when performing experiments with this algorithm in large 
datasets, it is highly recommended to set up the option `mem_mb` to limit
the memory that the Snakemake can use. Otherwise, it is likely you will
need to force restart your computer because you will run out of memory.

To run manually this script, see how it can be executed:
```
python3 slim_upc.py -h
```

REF: Refer to paper "*Slim: Directly Mining Descriptive Patterns*"
for more information.
